import Bladex
import Enm_Def
import AniSound
import BCopy
import Reference
import Combat
import whrandom
import AuxFuncs
import GenFX
import darfuncs
import EnemyTypes
import CharStats
import InitDataField
import Actions
import math
import Blood
import Damage
import dust
import GameStateAux
# Boolean value
TRUE = 1==1
FALSE = not TRUE





class Pro3ChaosKnight (EnemyTypes.ChaosKnight):

	Deathfunc=None
	Deathargs=()
	
	def __init__(self, me):
		EnemyTypes.ChaosKnight.__init__(self, me)
		
		me.ImDeadFunc=self.ImDeadFunc
		
		self.dissappsound1=Bladex.CreateSound("..\\..\\Sounds\\M-RUMBLE-ROCA.wav", "DissappSound1")
		self.dissappsound1.Volume=1.0
		self.dissappsound1.MinDistance=10000
		self.dissappsound1.MaxDistance=20000
		self.dissappsound2=Bladex.CreateSound("..\\..\\Sounds\\M-IMPACTO-FUEGO.wav", "DissappSound2")
		self.dissappsound2.Volume=0.6
		self.dissappsound2.MinDistance=10000
		self.dissappsound2.MaxDistance=20000
	
	
	
	def ImDeadFunc (self,EntityName):
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		me = Bladex.GetEntity(EntityName)
		x,y,z=me.Position
		self.dissappsound1.Play(x, y, z, 0)
		darfuncs.Temblores(1.5,30)
		DeathCloud=Bladex.CreateEntity("DeathCloud-" + me.Name, "Entity Particle System Dperson", 0.0, 0.0, 0.0)
		DeathCloud.PersonName		= me.Name
		DeathCloud.ParticleType		= "DeathCloud"
		DeathCloud.Time2Live		= 64
		DeathCloud.RandomVelocity	= 5
		DeathCloud.Velocity		= 0,0,0
		DeathCloud.NormalVelocity	= 3.0
		DeathCloud.YGravity		= -100
		DeathCloud.FollowFactor		= 0.5
		DeathCloud.DeathTime		= Bladex.GetTime() + 7.5
		DeathCloud.PPS			= 400
		me.Alpha=1.0
		me.RasterMode="Read"
		me.CastShadows=0
		AuxFuncs.FadeObject(me.Name, 1.00, 0.0, 9.0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+6.0,self.dissappsound2.Play,(x, y, z, 0,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+15.0,me.SubscribeToList,("Pin",))
		
		ListaDeNodos=("Head", "L_Shoulder", "L_Elbow", "L_Hand", "R_Shoulder", "R_Elbow", "R_Hand", "Center", "L_Knee", "L_Foot", "R_Knee", "R_Foot")
		GenFX.ElectricDischarge(me.Name, "ElectricBolt-" + me.Name, 255, 40, 10, 600, ListaDeNodos, 8, 7)
		if self.Deathfunc:
			apply(self.Deathfunc,self.Deathargs)
		# Destroy Weapons

		Bladex.AddScheduledFunc(Bladex.GetTime()+5,self.DestroyWeapons,(EntityName,))


	def DestroyWeapons(self,EntityName):
		print"start destroy weapons"
		if self.RightWeapon:
			Bladex.AddScheduledFunc(Bladex.GetTime()+1, self.DestroySword,(self.RightWeapon,))
		if self.LeftWeapon:
			Bladex.AddScheduledFunc(Bladex.GetTime()+1.6, self.DestroyShield,(self.LeftWeapon,))
		
		
	def DestroySword(self,Sword):
		flash1 = Bladex.CreateEntity("SwordFlash1", "Entity Particle System Dobj", 0,0,0)
		flash1.ObjectName=Sword
		flash1.ParticleType   = "EnergyConc"
		flash1.YGravity       = 0 
		flash1.Friction       = 0
		flash1.PPS            = 400
		flash1.Velocity       = 0,0,0 
		flash1.Time2Live      = 60 
		flash1.RandomVelocity = -5
		flash1.NormalVelocity = -8.0
		flash1.DeathTime=Bladex.GetTime()+3.0
		AuxFuncs.FadeObject(Sword,1.0,0.0,4)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.1,self.DumpIt,(Sword,))
		print"Sword vanishing"
		
	def DestroyShield(self,Shield):
		flash2 = Bladex.CreateEntity("ShieldFlash1", "Entity Particle System Dobj", 0,0,0)
		flash2.ObjectName=Shield
		flash2.ParticleType   = "EnergyConc"
		flash2.YGravity       = 0 
		flash2.Friction       = 0
		flash2.PPS            = 400
		flash2.Velocity       = 0,0,0 
		flash2.Time2Live      = 60 
		flash2.RandomVelocity = -5
		flash2.NormalVelocity = -8.0
		flash2.DeathTime=Bladex.GetTime()+3.0
		AuxFuncs.FadeObject(Shield,1.0,0.0,4)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7.1,self.DumpIt,(Shield,))
		print"Shield vanishing"


	def DumpIt(self,Thing):
		obj=Bladex.GetEntity(Thing)
		obj.Position=0,0,40000
		print "_dumped"
	
	
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=EnemyTypes.ChaosKnight.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		me=Bladex.GetEntity(self.Name)
		NPCPerson_state[1]["Pro3ChaosKnight"]=(GameStateAux.SaveFunctionAux(self.Deathfunc),
		                                       self.Deathargs,
		                                       self.dissappsound1,
		                                       self.dissappsound2)
		return NPCPerson_state
	
	def __setstate__(self,parm):
		EnemyTypes.ChaosKnight.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Pro3ChaosKnight"]
			GameStateAux.LoadFunctionAux(parms[0],self,"Deathfunc")
			self.Deathargs=parms[1]
			self.dissappsound1=parms[2]
			self.dissappsound1=parms[3]
			
			

########################################################################################################################################################

class Ultra_Barb (Enm_Def.NPCPerson):

	UBParticleData=[]
	Powerup=0
	Powuptime=15.0
	
	def __init__(self, me):
		# base class init
		Enm_Def.NPCPerson.__init__(self, me)
		
		self.UBParticleData=[]
		
		me.SetMesh ('BarSkin2')
	
		me.ImDeadFunc=self.NewImDeadFunc
		
		
		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 #va de 0 a 1
				aux=traux**0.5
			else:
				traux=i/25.0 #va de 1 a 0
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.UBParticleData.append(a)
			self.UBParticleData.append(size)
			Bladex.SetParticleGVal("UBParticle",i,r,g,b,a,size)
			
		
		self.ublupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-espada.wav", "UBLUPSnd1")
		self.ublupsnd1.Volume=1.0
		self.ublupsnd1.MinDistance=10000
		self.ublupsnd1.MaxDistance=30000	
		self.ublupsnd2=Bladex.CreateSound("..\\..\\Sounds\\luz.wav", "UBLUPSnd2")
		self.ublupsnd2.Volume=1.0
		self.ublupsnd2.MinDistance=10000
		self.ublupsnd2.MaxDistance=30000	
		
		
	def NewImDeadFunc (self,EntityName):
		self.Powerup==2
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
	
	
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosBarbaro(EntityName)
		
		try:
			Bladex.ReadBitMap("../../Maps/FugitiveI/Ubarb.bmp","UbarbIcon")#########
			Reference.EnemiesScorerData[self.Name]=("UbarbIcon","Ubarb")
		except:
			Bladex.ReadBitMap("../../Data/Icons/iconobarbaro.bmp","BarbarianIcon")
			Reference.EnemiesScorerData[self.Name]=("BarbarianIcon","Barbarian")
		
		
		
	# Functions for loading and saving state
	def __getstate__(self):	
		#print "Changed Funcs",self.changed_func
		
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Ultra_Barb.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["Ultra_Barb"]=(self.Powerup,self.Powuptime)
		return NPCPerson_state
	
	
	
	
	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Ultra_Barb"]
			self.Powerup=parms[0]
			self.Powuptime=parms[1]
		self.UBParticleData=[]
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.UBParticleData.append(a)
			self.UBParticleData.append(size)
			Bladex.SetParticleGVal("UBParticle",i,r,g,b,a,size)
		
		self.ublupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-espada.wav", "UBLUPSnd1")
		self.ublupsnd1.Volume=1.0
		self.ublupsnd1.MinDistance=10000
		self.ublupsnd1.MaxDistance=30000	
		self.ublupsnd2=Bladex.CreateSound("..\\..\\Sounds\\luz.wav", "UBLUPSnd2")
		self.ublupsnd2.Volume=1.0
		self.ublupsnd2.MinDistance=10000
		self.ublupsnd2.MaxDistance=30000	
		
		


	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 2.0
			me.BlockingPropensity = 0.8
			me.AttackList = BCopy.deepcopy(Ultra_BarbAttackData)
			self.ChanceOfFuryOnHurt = 0.00
			self.ChanceOfFuryOnLeaderDeath = 1.00
			rwp=me.InvRight
			if rwp:
				print EntityName+"_Holding_"+rwp
				flag=Reference.GiveWeaponFlag(rwp)
				if flag==Reference.W_FLAG_AXE:
									
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GI_AXE",)  ,0.0, 2500.0, 3500.0, 0.35],)    # Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM17_AXE",),1200.0, 2500.0, 3500.0, 0.35],) # High Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM28_AXE",),1200.0, 2500.0, 3500.0, 0.35],) # Low Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM21_AXE",),1200.0, 2500.0, 3500.0, 0.35],) # Left Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM19_AXE",),1200.0, 2500.0, 3500.0, 0.35],) # Right Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM18_AXE",),1500.0, 2500.0, 3500.0, 0.35],) 
	    				me.AttackList.append ([Combat.ATTACK, 0.03, ("GM31_AXE",),1500.0, 2500.0, 3500.0, 0.35],)    # Shredder
					me.AttackList.append ([Combat.ATTACK, 0.03, ("GM26_AXE",),1200.0, 1600.0, 2500.0, 0.35],)    # BlindRage
            				me.AttackList.append ([Combat.ATTACK, 0.03, ("GM27_AXE",),1200.0, 1600.0, 2500.0, 0.35],)    # Overkill
            				me.AttackList.append ([Combat.ATTACK, 0.001, ("GM27_AXE",),3500.0, 5010.0, 9001.0, 0.35],)
					print "enable axe moves"
				
				if flag==Reference.W_FLAG_2W:
			
					me.AttackList.append ([Combat.ATTACK, 0.09, ("GM12_2H",),1200.0, 1600.0, 2500.0, 0.35],)     # Death Sweep
            				me.AttackList.append ([Combat.ATTACK, 0.09, ("GM9_2H",),1200.0, 1600.0, 2500.0, 0.35],)      # Hellthrust
            				me.AttackList.append ([Combat.ATTACK, 0.12, ("GM6_2H",),1200.0, 1600.0, 2500.0, 0.35],)      # Speed Kill
            				me.AttackList.append ([Combat.ATTACK, 0.05, ("GI_2H",), 1500.0, 2500.0, 3500.0, 0.35],)      # Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM1_2H",),1500.0, 2500.0, 3500.0, 0.35],)      # High Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM10_2H",),1500.0, 2500.0, 3500.0, 0.35],)     # Low Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM7_2H",),1500.0, 2500.0, 3500.0, 0.35],)      # Left Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM4_2H",),1500.0, 2500.0, 3500.0, 0.35],)      # Right Attack 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM2_2H",),1500.0, 2500.0, 3500.0, 0.35],) 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM5_2H",),1500.0, 2500.0, 3500.0, 0.35],) 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM8_2H",),1500.0, 2500.0, 3500.0, 0.35],) 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM11_2H",),1500.0, 2500.0, 3500.0, 0.35],) 
	    				me.AttackList.append ([Combat.ATTACK, 0.05, ("GM2_2H",),1500.0, 2500.0, 3500.0, 0.35],) 
	    				print"enable sword moves"
	    			
	    			
	    
	def UBLUP2(self):
		AuraParams=(5, 0, 1, 0, 0, 1)
		AuraGradient=(2, 1.0, 0.4, 0.2, 0.5, 0.0, 1.0, 0.15, 0.04, 0.0, 0.8)
		AuraVar1Args=(5, 200, 0, 1, 1.0)
		AuraVar2Args=(200, 5, 1, 0, 1.5)
		PSParams=(self.UBParticleData, "DGLevelUpParticle", 30, 255, 40, 10, 400, -600, 0.0, 2, 2, 0.4, 30, 1.6)
		GenFX.LevelUpFX(self.Name, 0, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, 4.0, "Timer15", 15,)
		list_of_nodes=("Head", "L_Shoulder", "L_Elbow", "L_Hand", "R_Shoulder", "R_Elbow", "R_Hand", "Center", "L_Knee", "L_Foot", "R_Knee", "R_Foot")
		GenFX.ElectricDischarge(self.Name, "UBRayLevelUp", 255, 40, 10, 600, list_of_nodes, 10, 1.5)
	
	
	def UBLUP1(self,EntityName):
		pslup=Bladex.CreateEntity("PSUBLifeUp", "Entity Particle System Dperson", 0, 0, 0)
		pslup.PersonName=self.Name
		pslup.ParticleType="DGLifeUpEnergyConc"     
		pslup.PPS=400
		pslup.YGravity=0
		pslup.Friction=0.0
		pslup.RandomVelocity=-2
		pslup.NormalVelocity=-20
		pslup.FollowFactor=0.0
		pslup.Time2Live=50
		pslup.Velocity=0.0, 0.0, 0.0
		pslup.DeathTime=Bladex.GetTime()+1.0
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.9, self.UBLUP2, ())
		
		
	def RestoreVunerabilty(self,EntityName):
		self.Invincibility=0	
		
			
	def RestoredTimer(self, EntityName, time):
		me = Bladex.GetEntity(EntityName)
		me.Life = me.Life+20                                          
		maxpoints=CharStats.GetCharMaxLife(me.Kind, me.Level)                                          
		if me.Life>maxpoints-30:
			me.Life=maxpoints
			me.RemoveFromList("Timer60")
			me.TimerFunc=""
			print("full life")
			self.RestoreVunerabilty(EntityName)
		
			
	def ReCharge (self,EntityName):
		print "recharging"
		me = Bladex.GetEntity(EntityName)
		me.Wuea=Reference.WUEA_ENDED
		me.InterruptCombat()
		me.LaunchAnmType("powup")
		me.SetOnFloor()
		if me.Level < 19:
			me.Level = me.Level +1
		me.TimerFunc=self.RestoredTimer
		me.SubscribeToList("Timer60")
		self.Invincibility=1
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.4,self.UBLUP1,(EntityName,))
		snd_pos=me.Position
		self.ublupsnd1.Play(snd_pos[0], snd_pos[1], snd_pos[2], 0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,self.ublupsnd2.Play,(snd_pos[0], snd_pos[1], snd_pos[2], 0,))
			
			
	def StartPowerupPhase (self,EntityName):
		self.Powerup=1
		self.PeriodicLifeCheck(EntityName)
	
	
	def PeriodicLifeCheck(self,EntityName):
		self.Powuptime=self.Powuptime+7
		me = Bladex.GetEntity(EntityName)
		if me.Life>0 and self.Powerup==1:
			if me.Life<CharStats.GetCharMaxLife(me.Kind, me.Level)* 0.3:
				self.ReCharge(EntityName)
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.Powuptime, self.PeriodicLifeCheck,(EntityName,))
	
		
				
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		Enm_Def.NPCPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		me = Bladex.GetEntity(EntityName)
		if self.Powerup==0:
			self.StartPowerupPhase(EntityName)
			print"UBarb Starting Powerup Phase"
			
		
Ultra_BarbAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.25, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.07, (),                  3000.0, 4000.0, 5000.0, 0.50],
            [Combat.BLOCK,  0.35, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.245, "tb",               3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [Combat.DODGE,  0.30, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.30, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.30, "d_b",                500.0, 1200.0, 2800.0, 0.35],
   
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            
            
	    [Combat.MOVE,   0.03, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.03, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [Combat.MOVE,   0.03, "tr",                5000.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.03, "tl",                5000.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.05, "tb",                5000.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.03, "tf",                5001.0, 7000.0, 9000.0, 0.50, 1],

            [Combat.MOVE,   0.15, Combat.TempMoveInProc,      3000.0,  7000.0, 9000.0, 0.35, 1],
            [Combat.MOVE,   0.25, Combat.TempMoveOutProc,     3000.0,  3000.0, 7000.0, 0.35, 1],
]




##########################################################################################################################################################

class Super_Knt (Enm_Def.NPCPerson):
	def __init__(self, me):
		# base class init
		Enm_Def.NPCPerson.__init__(self, me)
		#print "Personage Creado",me.Name,self.changed_func

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosCaballero(EntityName)
		me=Bladex.GetEntity(EntityName)
		if me.MeshName=="Dark_Knight":
			Bladex.ReadBitMap("../../Data/Icons/Knight Dark.bmp","DarkKnightIcon")
			Reference.EnemiesScorerData[self.Name]=("DarkKnightIcon","Dark_Knight")	
		else:
			Bladex.ReadBitMap("../../Data/Icons/icono caballero.bmp","KnightIcon")
			Reference.EnemiesScorerData[self.Name]=("KnightIcon","Kgt")	
		

	# Functions for loading and saving state
	def __getstate__(self):	
		#print "Changed Funcs",self.changed_func
		
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Super_Knt.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["Super_Knt"]=()
		return NPCPerson_state
	
	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)

	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 1.5
			me.BlockingPropensity = 0.7
			me.AttackList = BCopy.deepcopy(Super_KntAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00

		
	
Super_KntAttackData = [
	# inner zone blocks:
	[Combat.BLOCK,  0.20, "tr",                 750.0, 1500.0, 3500.0, 0.50],
	[Combat.BLOCK,  0.20, "tl",                 750.0, 1500.0, 3500.0, 0.50],
	[Combat.BLOCK,  0.20, "tb",                 750.0, 1500.0, 3500.0, 0.50],
    	[Combat.BLOCK,  0.40, "tf",                 750.0, 1500.0, 3500.0, 0.50],

    	# outer zone blocks:
    	[Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
    	[Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
    	[Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
    	[Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

	# dodges
    	[Combat.DODGE,  0.15, "d_r",                0.0, 1200.0, 2800.0, 0.35],
    	[Combat.DODGE,  0.15, "d_l",                0.0, 1200.0, 2800.0, 0.35],
    	[Combat.DODGE,  0.10, "d_b",                0.0, 1200.0, 2800.0, 0.35],

	# basic attacks
	[Combat.ATTACK, 0.05, ("GI_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Attack 
	[Combat.ATTACK, 0.05, ("GM1_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light High Attack 
	[Combat.ATTACK, 0.05, ("GM8_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Low Attack 
	[Combat.ATTACK, 0.05, ("GM6_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Left Attack 
	[Combat.ATTACK, 0.05, ("GM3_1H",),            1200.0, 1800.0, 2500.0, 0.35], # Light Right Attack 

    	# inner zone moves:
    	[Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.MOVE,   0.15, "tb",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.MOVE,   0.10, "tf",                   0.0, 2000.0, 5000.0, 0.35],
    	[Combat.ATTACK, 0.12, ("GM17_1H",), 	      1200.0, 1600.0, 2500.0, 0.35],        #hawk attack
    	[Combat.ATTACK, 0.12, ("GM5_1H",), 	      1200.0, 1600.0, 2500.0, 0.35],        #soul of hounour
    	[Combat.ATTACK, 0.12, ("GM35_1H",), 	      1200.0, 1600.0, 2500.0, 0.35],        #righteous anger
    	[Combat.ATTACK, 0.02, ("GM23_1H","GM24_1H",), 1200.0, 1600.0, 2500.0, 0.35],        
    	[Combat.ATTACK, 0.12, ("GM23_1H",), 	      1200.0, 1600.0, 2500.0, 0.35],        
    	
    	[Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
    	[Combat.MOVE,   0.10, Combat.TempMoveInProc,      3000.0,  7000.0, 9000.0, 0.35, 1],
        [Combat.MOVE,   0.05, Combat.TempMoveOutProc,     3000.0,  3000.0, 7000.0, 0.35, 1],
]





class MagicOrk (EnemyTypes.Ork):
	
	def __init__(self, me):
		# base class init
		EnemyTypes.Ork.__init__(self, me)
		
		me.MutilateFunc=self.NewMutilateFunc
		
		
	def NewMutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		#Blood.Mutilate (EntityName,obj_name,x,y,z,nx,ny,nz,node)
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		limb.CastShadows=0
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, AuxFuncs.FadeObject,(obj_name,1.0,0.0,2.0))
		Bladex.AddScheduledFunc(Bladex.GetTime()+3.1, limb.SubscribeToList,("Pin",))
		





		
def Kgt_g_s28kata_new_FX(EntityName, EventName):
	global ComboFX_prtlsys
	step=int(EventName[len(EventName)-1:])
	if step==1:
		pers=Bladex.GetEntity(EntityName)
		inv=pers.GetInventory()
		ComboFX_prtlsys=GenFX.AddParticles(inv.GetActiveWeapon(), "RedTrail", 2000, 3, 0, 0.1, 20, 1.3)		
		
		
class KingSkeleton (Enm_Def.NPCPerson):

	def __init__(self, me):
		# base class init		
		Enm_Def.NPCPerson.__init__(self, me)

		# anims
		#me.AnmTranFunc=AuxTran.AuxTranKnightLivingDead

		# Set up skeleton specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   =  1.0
		self.SoundPriorities[Reference.SND_HIT]     =  1.0
		self.SoundPriorities[Reference.SND_NPC]     = -1.0
		self.SoundPriorities[Reference.SND_NOISYPC] =  3.0
		self.SoundPriorities[Reference.SND_PC]      =  2.0
		me.ImDeadFunc=self.ImDeadFunc
		
		me.AddAnmEventFunc("Kgt_g_s28kata_new_1", Kgt_g_s28kata_new_FX)


	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosEsqueleto(EntityName)
		
		me=Bladex.GetEntity(EntityName)
		
		from AniSoundKgtX import *
		
		me.AddAnimSound('Kgt_g_s28kata_new', SesgadoEspecialCorto2, 0.2640)
		me.AddAnimSound('Kgt_g_s28kata_new', SesgadoEspecialLargo2, 0.4550)
		
	
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.BlockingPropensity = 0.6
			me.AttackList = BCopy.deepcopy(KingSkeletonAttackData)
			
					
	def ImDeadFunc (self,EntityName):
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		


	# Functions for loading and saving state
	def __getstate__(self):
		# Tiene que devolver cmo poder guardar el estado de la clase
		
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)		

		if(NPCPerson_state[0]!=1):
			print "ERROR: Skeleton.__getstate__(): Base class version differs."
			
			return NPCPerson_state
		NPCPerson_state[1]["KingSkeleton"]=()

		return NPCPerson_state
		#self.ResetCombat(me.Name)

	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["KingSkeleton"]
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("Kgt_g_s28kata_new_1", Kgt_g_s28kata_new_FX)
		
		
		
		
		
	def PutOnCrown(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		me.Freeze()
		angle=me.Angle
		pos=me.Position
		me.Position=-23163.0827333,-1024.6568251,-10431.7931571
		me.Angle=2.82
		crwn=Bladex.CreateEntity(EntityName+"Crown","Corona",-23163.0827333,-1884.6568251,-10571.7931571,"Physic")
		crwn.Orientation=(0.780330061913,0.609789431095,0.05618622154,-0.126826450229)
		me.LinkToNode(crwn, me.GetNodeIndex("Head"))
		me.Angle=angle
		me.Position=pos[0],pos[1],pos[2]
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,me.UnFreeze,())
		
		
def ExtraAnmForKingSkeleton ():
	Kskl=Bladex.GetCharType("Skeleton","Skl")
	Bladex.AddBipedAction("Skeleton","Kgt_g_s28kata_new","Kgt_g_s28kata_new",0.0,1.0,0)
	Kskl.AddAttack("GM36_1H","Kgt_g_s28kata_new")
	Kskl.AttackWindow("Kgt_g_s28kata_new",0.600,0.821,"GM36_1H_Window")
	Kskl.AssignTrail("GM36_1H","","EstelaRoja1")
	Kskl.AddLevels("Kgt_g_s28kata_new",6,40)
	Kskl.AddEnergyLevel("Kgt_g_s28kata_new", 0)
	Bladex.SetAnimationFactor("Kgt_g_s28kata_new",3.3)
	Bladex.AddAnmEvent("Kgt_g_s28kata_new","Kgt_g_s28kata_new_1",0.300)
       
	
 	
KingSkeletonAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.30, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.08, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.08, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.08, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
           # attacks:
            [Combat.ATTACKDOWN, 1.00, ("STAIRS",),         1200.0, 1600.0, 2500.0, 0.35],
            
            [Combat.ATTACK, 0.00, ("GA","GA","GA","GM1",),1200.0, 1400.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.50, ("GA",),                1200.0, 1400.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.40, ("GM2",),               0.0, 1600.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.40, ("GA", "GA"),           1200.0, 1600.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.10, ("GA", "GA", "GM1"),    0.0, 1600.0, 3000.0, 0.35],
            [Combat.ATTACK, 0.25, ("GM2",),               1200.0, 1800.0, 2500.0, 0.35],
            #[Combat.ATTACK, 0.25, ("G22",),              2014.0, 3000.0, 5327.0, 0.35],
            [Combat.ATTACK, 1.00, "RespectDistance",      0.0,  500.0, 1200.0, 0.30,1],
            
            [Combat.ATTACK, 0.20, ("GM36_1H",),           800.0, 1500.0, 3000.0, 0.35],

           # inner zone moves:
            [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.50],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.50],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.50],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.50],

           # outer zone moves:
            [Combat.MOVE,   0.01, "tr",                5000.0, 7000.0, 9000.0, 0.50],
            [Combat.MOVE,   0.01, "tl",                5000.0, 7000.0, 9000.0, 0.50],
            [Combat.MOVE,   0.05, "tb",                5000.0, 7000.0, 9000.0, 0.50],
            [Combat.MOVE,   0.02, "tf",                5000.0, 7000.0, 9000.0, 0.50],
            [Combat.MOVE,   0.06, Combat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
]



class FIVamp (Enm_Def.NPCPerson):


	Fader= None
	FadeOutTime= 0.45
	FadeInTime= 0.65
	TransitTime= 0.20
	Enemy=None
	EnemyAngle=0.0

	def __init__(self, me):
		# base class init
		Enm_Def.NPCPerson.__init__(self, me)

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		# constants
		FadeList=[me.Name]
		if Actions.StatR(me.Name)!=Actions.RA_NO_WEAPON:
			FadeList.append (me.InvRight)
		if Actions.StatL(me.Name)!=Actions.LA_NO_WEAPON:
			FadeList.append (me.InvLeft)
		self.Fader= EnemyTypes.EntitiesFader (FadeList)

		me.AddAnmEventFunc("Disappear", self.DisappearEvent)

		me.ImDeadFunc=self.ImDeadFunc
		me.MutilateFunc=self.MutilateFunc

	# Functions for loading and saving state
	def __getstate__(self):
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			print "ERROR: Vamp.__getstate__(): Base class version differs."			
			return NPCPerson_state
		NPCPerson_state[1]["FIVamp"]=(self.Enemy, self.EnemyAngle)
		return NPCPerson_state		

	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["FIVamp"]
			self.Enemy=parms[0]
			self.EnemyAngle=parms[1]
		
		me=Bladex.GetEntity(self.Name)
		# Create a linear interpolator for fading
		FadeList=[me.Name]
		if Actions.StatR(me.Name)!=Actions.RA_NO_WEAPON:
			FadeList.append (me.InvRight)
		if Actions.StatL(me.Name)!=Actions.LA_NO_WEAPON:
			FadeList.append (me.InvLeft)
		self.Fader= EnemyTypes.EntitiesFader (FadeList)
		self.FadeOutTime= 0.45
		self.FadeInTime= 0.65
		self.TransitTime= 0.20
		me.AddAnmEventFunc("Disappear", self.DisappearEvent)
			
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosVampiro(EntityName)

	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me= Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind= FALSE
			self.AttackNPCTime= 2.0
			inv= me.GetInventory()
			if inv.HoldingShield: 
				me.BlockingPropensity = 1.0
				me.RangeDefenceCapable = TRUE
			else: 
				me.BlockingPropensity = 0.2
				me.RangeDefenceCapable = FALSE
			me.AttackList= BCopy.deepcopy(FIVampireAttackData)
			self.ChanceOfFuryOnHurt = 0.2
			self.ChanceOfFuryOnLeaderDeath= 0.0
	
	def FadeOut (self,EntityName):
		self.Fader.FadeOut(self.FadeOutTime)
	
	def FadeIn (self,EntityName):
		self.Fader.FadeIn(self.FadeInTime)

	def DisappearEvent (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		# May wish to make all attacks pass through...
		self.FadeOut(EntityName)
		time= Bladex.GetTime()
		Bladex.AddScheduledFunc(time+self.FadeOutTime+self.TransitTime, self.Reappear, (EntityName,), EntityName+" Reappear")
		if Actions.StatR(EntityName)!=Actions.RA_NO_WEAPON:
			weapon= Bladex.GetEntity(me.InvRight)
			weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
			weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
	
	def Disappear (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		forgetit= (me.Life*2.0)/CharStats.GetCharMaxLife(me.Kind, me.Level)
		if whrandom.random()>forgetit:# or not Actions.IsFacingEntity(me.GetEnemyName(), EntityName):
			me.SetNextAttack("disappear")
			return 1
		return 0
		
		
	def RelativeEnemyAngle2PositionAngleTuple (self, angle):
		angle= angle+self.EnemyAngle
		# Compensate for non forward attack
		#angle= angle - (25.0/360.0)*Actions.TWOPI
		
		if angle > Actions.PI*2.0:
			angle= angle-Actions.TWOPI
		elif angle < 0.0:
			angle= angle+Actions.TWOPI
		
		# What distance to use?
		pos= self.Enemy.Position
		dist= 1400
		pos= pos[0]+dist*math.sin(angle), pos[1], pos[2]-dist*math.cos(angle)
		return (pos, angle)
	
	def Reappear (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		# Find a suitable position to reappear in
		if whrandom.random() < 0.5:
			RelAngles=[0, Actions.PI*0.25, Actions.PI*-0.25, Actions.PI*0.5, Actions.PI*-0.5, Actions.PI*0.75, Actions.PI*-0.75]
		else:
			RelAngles=[0, Actions.PI*-0.25, Actions.PI*0.25, Actions.PI*-0.5, Actions.PI*0.5, Actions.PI*-0.75, Actions.PI*0.75]		
		#pdb.set_trace()
		self.Enemy= Bladex.GetEntity(me.GetEnemyName())
		self.EnemyAngle= self.Enemy.Angle
		ReentryInfo= map(self.RelativeEnemyAngle2PositionAngleTuple, RelAngles)
		
		# Add current position, unnecessary
		#ReentryInfo.append ((me.Position, me.Angle))
		
		max_fall= 1000.0
		for info in ReentryInfo:
			if me.TestPos (info[0][0],info[0][1],info[0][2], me.ActionAreaMax,max_fall):
				me.Position= info[0][0],info[0][1],info[0][2]
				me.Angle= info[1]
				me.SetOnFloor()
				break
		
		# Maybe break enemies facing mode
		if self.Enemy.InCombat and self.Enemy.ActiveEnemy==me.Name and not self.Enemy.CanISee(me):
			self.Enemy.SetActiveEnemy(None)
		self.FadeIn(EntityName)
		if Actions.StatR(EntityName)!=Actions.RA_NO_WEAPON:
			#Bladex.GetEntity(me.InvRight).MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
			dice= whrandom.random()
			if dice<0.2:
				me.SetNextAttack("g_01")
			elif dice<0.4:
				me.SetNextAttack("g_06")
			elif dice<0.6:
				me.SetNextAttack("g_07")
			#elif dice<0.8:
			#	me.SetNextAttack("g_26")


	def InteruptActions(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.Wuea=Reference.WUEA_ENDED
		me.InterruptCombat()
		me.Data.Fader.Stop()
		Bladex.RemoveScheduledFunc(me.Name+" Reappear")
		
	
	def ImDeadFunc (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		rwp=Bladex.GetEntity(me.InvRight)
		lwp=Bladex.GetEntity(me.InvLeft)
		if rwp:
			Bladex.AddScheduledFunc(Bladex.GetTime()+5.0,AuxFuncs.FadeObject,(rwp.Name, 1.00, 0.0, 5.0,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+10.1,rwp.SubscribeToList,("Pin",))
		if lwp:
			Bladex.AddScheduledFunc(Bladex.GetTime()+4.0,AuxFuncs.FadeObject,(lwp.Name, 1.00, 0.0, 5.0,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+9.1,lwp.SubscribeToList,("Pin",))
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		DeathCloud=Bladex.CreateEntity("DeathCloud-" + me.Name, "Entity Particle System Dperson", 0.0, 0.0, 0.0)
		DeathCloud.PersonName		= me.Name
		DeathCloud.ParticleType		= "DeathCloud"
		DeathCloud.Time2Live		= 64
		DeathCloud.RandomVelocity	= 5
		DeathCloud.Velocity		= 0,-1000,0
		DeathCloud.NormalVelocity	= 3.0
		DeathCloud.YGravity		= -100
		DeathCloud.FollowFactor		= 0.5
		DeathCloud.DeathTime		= Bladex.GetTime() + 4.5
		DeathCloud.PPS			= 400
		me.Alpha=1.0
		me.RasterMode="Read"
		me.CastShadows=0
		Bladex.AddScheduledFunc(Bladex.GetTime()+9.0,AuxFuncs.FadeObject,(EntityName, 1.00, 0.0, 4.0,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+14.0,me.SubscribeToList,("Pin",))
		
		
		
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		Blood.Mutilate (EntityName,obj_name,x,y,z,nx,ny,nz,node)
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+8.0,AuxFuncs.FadeObject,(obj_name, 1.00, 0.0, 4.0,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+13.0,limb.RemoveFromWorld,())
		
		
FIVampireAttackData =	[ 
           # inner zone blocks:
            [Combat.BLOCK,  1.32, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.32, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.10, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.14, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.19, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # dodges:  sometimes the best form of defence is to attack...
            #[Combat.DODGE,  0.90, ("g_26",),            500.0, 1800.0, 2930.0, 0.35],
            [Combat.DODGE,  0.90, Combat.Disappear,      1500.0, 1800.0, 4930.0, 0.35],

           # attacks:
            [Combat.ATTACK, 0.15, ("disappear",),       500.0, 1000.0, 1200.0, 0.35],
            [Combat.ATTACK, 0.15, Combat.Disappear,     2000.0, 3000.0, 9000.0, 0.35],
            [Combat.ATTACK, 0.10, ("disappear",),      9000.0,10000.0,20000.0, 0.35],
            [Combat.ATTACK, 0.15, ("g_01",),            800.0, 2421.0, 3178.0, 0.35],
            [Combat.ATTACK, 0.12, ("g_06",),           1010.0, 2320.0, 2800.0, 0.35],
            [Combat.ATTACK, 0.15, ("g_07",),           1100.0, 2400.0, 3020.0, 0.35],
            [Combat.ATTACK, 0.01, ("g_26",),            1500.0, 2200.0, 3100.0, 0.35],
            
            [Combat.ATTACK, 0.03, ("COMBO1",),         1100.0, 2400.0, 2820.0, 0.35],
            [Combat.ATTACK, 0.03, ("COMBO2",),          800.0, 2421.0, 2978.0, 0.35],
            
            
           # inner zone moves:
            [Combat.MOVE,   0.025, "tr",                750.0, 1500.0, 3000.0, 0.35],
            [Combat.MOVE,   0.025, "tl",                750.0, 1500.0, 3000.0, 0.35],
            [Combat.MOVE,   0.0625,"tb",                750.0, 1500.0, 3000.0, 0.35],
            [Combat.MOVE,   0.0375,"tf",                750.0, 1500.0, 3000.0, 0.35],
            
           # outer zone moves:
            [Combat.MOVE,   0.002, Combat.Insult,             5000.0, 7000.0, 9000.0, 0.50,1],
            [Combat.MOVE,   0.002, Combat.Insult,             6000.0, 6250.0, 6500.0, 0.50,1],
            [Combat.MOVE,   0.002, Combat.Insult,             7000.0, 7250.0, 7500.0, 0.50,1],
            [Combat.MOVE,   0.002, Combat.Insult,             8000.0, 8250.0, 8500.0, 0.50,1],
            [Combat.MOVE,   0.002, Combat.Insult,             9000.0, 9250.0, 9500.0, 0.50,1],
            
            [Combat.MOVE,   0.025,  "tr",              3000.0, 3500.0, 4500.0, 0.35,1],
            [Combat.MOVE,   0.025,  "tl",              3000.0, 3500.0, 4500.0, 0.35,1],
            [Combat.MOVE,   0.0625,"tb",               3000.0, 3500.0, 4500.0, 0.35,1],
            [Combat.MOVE,   0.0375,"tf",               3000.0, 3500.0, 4500.0, 0.35,1],

            [Combat.MOVE,   0.80,  Combat.KeepDistance,       2800.0, 6250.0, 9500.0, 0.35,1],

]









class FlammableZombie (EnemyTypes.Lich):

	OnFire=0
	firelite=None
	
	def __init__(self, me):
		EnemyTypes.Lich.__init__(self, me)
		
		
		me.DamageFunc = self.ZombieDamage
		me.ImDeadFunc=self.ImDeadFunc
				
		self.firelite= Bladex.CreateEntity(me.Name+" FireLite", "Entity Spot", 0, 0, 0)
		self.firelite.Color= 200, 100, 0
		self.firelite.Intensity= 0.0
		self.firelite.Precission= 0.1
		self.firelite.Visible= 0
		self.firelite.CastShadows= 0
		self.firelite.SizeFactor  = 0
		me.Link(self.firelite)
		
	def BurnTimer(self, EntityName, time):
		me = Bladex.GetEntity(EntityName)
		life=me.Life
		nulife=life-3
		me.Life=nulife
		print"Zombie burning"
		if me.Life<0:
			me.RemoveFromList("Timer15")
			me.TimerFunc=""
			char=Bladex.GetEntity("Player1")
			char.Data.OnKilledEnemy(me.Name)
			print"Zombie ded"
		
		
	def ZombieBurn(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		me.TimerFunc=self.BurnTimer
		me.SubscribeToList("Timer15")
		AuxFuncs.SpotIntensityVariation(self.firelite.Name,0.0,8.0,4.0)
	
	
	
	def ZombieDamage(self,VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
		me = Bladex.GetEntity(VictimName)
		Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)
		print"ooow!"
		if WeaponName:	
			if Reference.EntitiesObjectData.has_key(WeaponName):
				if Reference.EntitiesObjectData[WeaponName][0] == Reference.OBJ_STANDARD:
					wpdata = Reference.EntitiesObjectData[WeaponName]
					wp=Bladex.GetEntity(WeaponName)
					if wpdata and len(wpdata) > 6:
						for special in wpdata[6:]:
							if special[0]=="Fire":
								if self.OnFire==0 and me.Life>20:
									self.OnFire=1
									me.CatchOnFire(0,0,0)
									Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,self.ZombieBurn,(VictimName,))
									print VictimName+" I am on fire"
				
				
	def ShadowsOff(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.CastShadows=0
		
		
	def ImDeadFunc (self,EntityName):
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		me = Bladex.GetEntity(EntityName)
		if self.OnFire==1:
			Bladex.AddScheduledFunc(Bladex.GetTime()+4.0,self.ShadowsOff,(EntityName,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+4.0,Actions.HumoDeFuego,(EntityName,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+4.1,AuxFuncs.SpotIntensityVariation,(self.firelite.Name,8.0,0.0,6.0,1,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+4.2,AuxFuncs.FadeObject,(EntityName,1.0,0.0,6,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+10.3,me.SubscribeToList,("Pin",))
		else:
			Bladex.AddScheduledFunc(Bladex.GetTime()+8.0,self.ShadowsOff,(EntityName,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+8.1, dust.EnPolvoPerson,(EntityName,100,0,))
				
				
				
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		me=Bladex.GetEntity(self.Name)
		NPCPerson_state[1]["FlammableZombie"]=(self.OnFire,self.firelite)            
		return NPCPerson_state
	
	def __setstate__(self,parm):
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["FlammableZombie"]
			self.OnFire=parms[0]
			self.firelite=parms[1]
			