import Bladex
import Scorer
import BUIx
import ScorerWidgets
import GameText
import Interpolator



wBigGameText=BUIx.B_TextWidget(Scorer.wFrame,"BigGameTextWidget","\n\n\n\n\n",ScorerWidgets.font_server,"../../Data/Letras menu gra.bmp")
wBigGameText.SetAlpha(1)
wBigGameText.SetColor(255,255,255)

Scorer.wFrame.AddWidget(wBigGameText,0.5,27,
                           BUIx.B_FrameWidget.B_FR_HRelative,BUIx.B_FrameWidget.B_FR_HCenter,
                           BUIx.B_FrameWidget.B_FR_AbsoluteBottom,BUIx.B_FrameWidget.B_FR_Bottom)

wBigGameText.SetAutoScale(1)


class FadeBigText(Interpolator.LinearInt):
  	def __init__(self,init_val,end_val):
    		Interpolator.LinearInt.__init__(self,init_val,end_val)
    		self.Interpolator=Interpolator.Interp("FadeBigText")
    		time=Bladex.GetTime()
    		self.Interpolator.AddAction(time,time+1.0,self)
   		self.end_val=end_val


  	def Execute(self,value):
    		ret=Interpolator.LinearInt.Execute(self,value)
    		wBigGameText.SetAlpha(ret)


  	def EndExecute(self):
    		self.Interpolator.Kill()
    		wBigGameText.SetAlpha(self.end_val)
    		if self.end_val==0:
     			 wBigGameText.SetText("")




def ClearBigText():
  	FadeBigText(1,0)





def WriteBigTextAux(txt,duration,init_r,init_g,init_b,next_text,ypos=None,patch=None):
	if Scorer.VISIBLE==0:
    		Scorer.wFrame.SetSize(20,20)
    		Scorer.wFrame.RecalcLayout()
  
  	wBigGameText.SetColor(init_r,init_g,init_b)
	wBigGameText.SetText(txt)
  	if ypos!=None:
   	 	Scorer.wFrame.MoveWidgetTo("BigGameTextWidget",0.5,ypos);
  	else:
    		Scorer.wFrame.MoveWidgetTo("BigGameTextWidget",0.5,27);
  		Scorer.wFrame.RecalcLayout()

  	GameText.FadeText(0,1)
  	now=Bladex.GetTime()

    	Bladex.AddScheduledFunc(now+duration,ClearBigText,(),"ClearBigText")
  	